subroutine forcecomp(mu,r,v,Rbn,hic_lhi,hull_cntct,phi_cntct,hull_cntct_in_xtr,hull_cntct_out_xtr,fcr,fshpsum,fvt,vnfip,vnlip,fshp)
implicit none
!
integer :: i, j, k
real(kind = 8), parameter :: pi = 3.14159265358979, thousand = 1000.0d0, zero = 1.0d-16, zero8 = 1.0d-8
!integer, parameter :: contact_dim = 500

real(kind = 8) :: mu
real(kind = 8) :: r(6), v(6)
real(kind = 8) :: Rbn(3,3)
integer :: hic_lhi
real(kind = 8) :: hull_cntct(2,500)                             ! in mm.
real(kind = 8) :: phi_cntct(500)
real(kind = 8) :: hull_cntct_in_xtr(2), hull_cntct_out_xtr(2)
real(kind = 8) :: fcr(500)                                      ! in N.

real(kind = 8) :: fshpsum(6)                                   
real(kind = 8) :: fvt, vnfip, vnlip

real(kind = 8) :: Rnb(3,3)
real(kind = 8) :: hull_cntct3d(3,500)
real(kind = 8) :: pan3dmp(3,500), pan3dmptemp(3,500), pan3dmpshp(3,500) ! pan3dmp - pan3d multiple points; pan3dmpshp is in mm.
real(kind = 8) :: vrttn(3,500)                          ! hull nodes velocity due to rotational velocities of COG, in ship's cs.  vrttn is in m/s.

real(kind = 8) :: pn(3,500)                             ! pn - foot of perpendicular, in m
real(kind = 8) :: rds(3,500)                            ! rotation radius
real(kind = 8) :: vtrns(3,500)                          ! hull nodes velocity due to translational velocities of COG, in ship's cs., in m/s
real(kind = 8) :: vnshp(3,500), vnfix(3,500)            ! vnshp - linear nodal velocities in ship's cs., in m/s.; vnfix - linear nodal velocities in inertial frame, is in m/s.
real(kind = 8) :: kappa(500)                            ! angle between inertial coord. and tau-n system.
real(kind = 8) :: Mtn(3,3,500), Mtnreverse(3,3,500)
real(kind = 8) :: vtnz(3,500)
real(kind = 8) :: Mtntemp(3,3)
real(kind = 8) :: vnfixtemp(3),vtnztemp(3)
real(kind = 8) :: frich(500), fricv(500)
real(kind = 8) :: ftnz(3,500)                           ! ftnz are forces on the ship, in N
real(kind = 8) :: ffix(3,500)
real(kind = 8) :: Mtnrvstemp(3,3)
real(kind = 8) :: ftnztemp(3), ffixtemp(3)
real(kind = 8) :: fshp(3,500)

!external  dgemm

Rnb = 0.0d0
hull_cntct3d = 0.0d0
pan3dmp = 0.0d0
pan3dmptemp = 0.0d0
pan3dmpshp = 0.0d0
vrttn = 0.0d0
pn = 0.0d0
rds = 0.0d0
vtrns = 0.0d0
vnshp = 0.0d0
vnfix = 0.0d0
kappa = 0.0d0
Mtn = 0.0d0
Mtnreverse = 0.0d0
vtnz = 0.0d0
Mtntemp = 0.0d0
vnfixtemp = 0.0d0
vtnztemp = 0.0d0
vnfip = 0.0d0
vnlip = 0.0d0
frich = 0.0d0
fricv = 0.0d0
ftnz = 0.0d0
ffix = 0.0d0
fvt = 0.0d0
Mtnrvstemp = 0.0d0
ftnztemp = 0.0d0
ffixtemp = 0.0d0
fshp = 0.0d0
fshpsum = 0.0d0


Rnb(1,1) = Rbn(1,1)
Rnb(2,1) = Rbn(1,2)
Rnb(3,1) = Rbn(1,3)
Rnb(1,2) = Rbn(2,1)
Rnb(2,2) = Rbn(2,2)
Rnb(3,2) = Rbn(2,3)
Rnb(1,3) = Rbn(3,1)
Rnb(2,3) = Rbn(3,2)
Rnb(3,3) = Rbn(3,3)

forall (i = 1:2, j=1:hic_lhi+2)
   hull_cntct3d(i,j) = hull_cntct(i,j)
end forall
forall (j = 1:hic_lhi+2)
    hull_cntct3d(3,j) = 0.0d0
end forall

forall (i = 1:3, j = 1:hic_lhi+2)
    pan3dmp(i,j) = r(i)*thousand
end forall

pan3dmptemp = hull_cntct3d - pan3dmp
      
do j = 1,hic_lhi+2
    do i = 1,3
        pan3dmpshp(i,j) = Rnb(i,1)*pan3dmptemp(1,j) + Rnb(i,2)*pan3dmptemp(2,j) + Rnb(i,3)*pan3dmptemp(3,j)
    end do
end do
!call DGEMM('n','n',3,n2-n1+2,3,1.0d0,Rnb,3,pan3dmptemp,3,0.0d0,pan3dmpshp,3)       ! coord. transf. from inertial frame to ship's cs.

if ((v(4)*v(4)+v(5)*v(5)+v(6)*v(6)) > zero) then
    forall (i = 1:3, j = 1:hic_lhi+2)
        pn(i,j) = v(i+3)/(v(4)*v(4) + v(5)*v(5) + v(6)*v(6))*(v(4)*pan3dmpshp(1,j)/thousand + v(5)*pan3dmpshp(2,j)/thousand + v(6)*pan3dmpshp(3,j)/thousand)
    end forall
    rds = pan3dmpshp/thousand - pn                                                 ! rds is in m.
    forall (j = 1:hic_lhi+2)                                                        ! or cross product operator could be used, where dgemm has to be called.
        vrttn(1,j) = v(5)*rds(3,j) - v(6)*rds(2,j)
        vrttn(2,j) = v(6)*rds(1,j) - v(4)*rds(3,j)
        vrttn(3,j) = v(4)*rds(2,j) - v(5)*rds(1,j)         
    end forall
end if

forall (i = 1:3, j = 1:hic_lhi+2)
    vtrns(i,j) = v(i)
end forall

vnshp = vrttn + vtrns               ! m/s

do j = 1,hic_lhi+2
    do i = 1,3
        vnfix(i,j) = Rbn(i,1)*vnshp(1,j) + Rbn(i,2)*vnshp(2,j) + Rbn(i,3)*vnshp(3,j)
    end do
end do
!call DGEMM('n','n',3,n2-n1+2,3,1.0d0,Rbn,3,vnshp,3,0.0d0,vnfix,3)

kappa(1) = 2.0d0*pi - datan2((hull_cntct_in_xtr(2) - hull_cntct(2,2)),(hull_cntct_in_xtr(1) - hull_cntct(1,2)))
if (hic_lhi==0) then
    continue
else if (hic_lhi==1) then
    kappa(2) = 2.0d0*pi - datan2((hull_cntct_in_xtr(2) - hull_cntct_out_xtr(2)),(hull_cntct_in_xtr(1) - hull_cntct_out_xtr(1)))
else if (hic_lhi==2) then
    kappa(2) = 2.0d0*pi - datan2((hull_cntct_in_xtr(2) - hull_cntct(2,3)),(hull_cntct_in_xtr(1) - hull_cntct(1,3)))
    kappa(3) = 2.0d0*pi - datan2((hull_cntct(2,2) - hull_cntct_out_xtr(2)),(hull_cntct(1,2) - hull_cntct_out_xtr(1)))
else if (hic_lhi>2) then
    kappa(2) = 2.0d0*pi - datan2((hull_cntct_in_xtr(2) - hull_cntct(2,3)),(hull_cntct_in_xtr(1) - hull_cntct(1,3)))
    do i = 3,hic_lhi
        kappa(i) = 2.0d0*pi - datan2((hull_cntct(2,i-1) - hull_cntct(2,i+1)),(hull_cntct(1,i-1) - hull_cntct(1,i+1)))
    end do
    kappa(hic_lhi+1) = 2.0d0*pi - datan2((hull_cntct(2,hic_lhi) - hull_cntct_out_xtr(2)),(hull_cntct(1,hic_lhi) - hull_cntct_out_xtr(1)))
end if
kappa(hic_lhi+2) = 2.0d0*pi - datan2((hull_cntct(2,hic_lhi+1) - hull_cntct_out_xtr(2)),(hull_cntct(1,hic_lhi+1) - hull_cntct_out_xtr(1)))

forall (k = 1:hic_lhi+2)
    Mtn(1,1,k) = dcos(kappa(k))
    Mtn(2,1,k) = dsin(kappa(k))
    Mtn(3,1,k) = 0.0d0
    Mtn(1,2,k) = -dsin(kappa(k))
    Mtn(2,2,k) = dcos(kappa(k))
    Mtn(3,2,k) = 0.0d0
    Mtn(1,3,k) = 0.0d0
    Mtn(2,3,k) = 0.0d0
    Mtn(3,3,k) = 1.0d0
end forall
   
forall (k = 1:hic_lhi+2)
    Mtnreverse(1,1,k) = dcos(kappa(k))
    Mtnreverse(2,1,k) = -dsin(kappa(k))
    Mtnreverse(3,1,k) = 0.0d0
    Mtnreverse(1,2,k) = dsin(kappa(k))
    Mtnreverse(2,2,k) = dcos(kappa(k))
    Mtnreverse(3,2,k) = 0.0d0
    Mtnreverse(1,3,k) = 0.0d0
    Mtnreverse(2,3,k) = 0.0d0
    Mtnreverse(3,3,k) = 1.0d0
end forall

do k = 1,hic_lhi+2
    Mtntemp = 0.0d0                  
    forall (i = 1:3, j = 1:3)
        Mtntemp(i,j) = Mtn(i,j,k)
    end forall
    vnfixtemp = 0.0d0
    forall (i = 1:3)
        vnfixtemp(i) = vnfix(i,k)
    end forall
    vtnztemp = 0.0d0
    do i = 1,3
        vtnztemp(i) = Mtntemp(i,1)*vnfixtemp(1) + Mtntemp(i,2)*vnfixtemp(2) + Mtntemp(i,3)*vnfixtemp(3)
    end do
    !call DGEMM('n','n',3,1,3,1.0d0,Mtntemp,3,vnfixtemp,3,0.0d0,vtnztemp,3)
    forall (i = 1:3)
        vtnz(i,k) = vtnztemp(i)                                                             ! vtnz is in m/s.
    end forall
end do

vnfip = vtnz(2,1)*dsin(phi_cntct(1)) - vtnz(3,1)*dcos(phi_cntct(1))
vnlip = vtnz(2,hic_lhi+2)*dsin(phi_cntct(hic_lhi+2)) - vtnz(3,hic_lhi+2)*dcos(phi_cntct(hic_lhi+2))       ! in m/s
   
do k = 1,hic_lhi+2
    if (vtnz(2,k)*dsin(phi_cntct(k)) - vtnz(3,k)*dcos(phi_cntct(k)) <= 0.0d0) then
        fcr(k) = 0.0d0
    end if
end do
   !write(*,*) 'mark9'
   !pause
   !write(*,*) 'hic_lhi+2:',hic_lhi+2
   !pause
   !write(*,*) 'start check phi_cntct:'
   !pause
   ! do k = 1,hic_lhi+2
        !if (phi_cntct(k)/=0) then
            !write(*,*) 'phi_cntct(',k,')',phi_cntct(k)
        !end if
    !end do
   !write(*,*) 'check over'
   !pause
   !write(*,*) 'fcr:',fcr
   !pause
do k = 1,hic_lhi+2                     ! the dim. of 'fcr' is used as 'N' in this subroutine
    if ((vtnz(1,k)*vtnz(1,k) + (vtnz(2,k)*dcos(phi_cntct(k)) + vtnz(3,k)*dsin(phi_cntct(k)))**2.0d0) > zero) then
        frich(k) = -mu*fcr(k)*vtnz(1,k)/dsqrt(vtnz(1,k)*vtnz(1,k) + (vtnz(2,k)*dcos(phi_cntct(k)) + vtnz(3,k)*dsin(phi_cntct(k)))**2.0d0)
        fricv(k) = -mu*fcr(k)*(vtnz(2,k)*dcos(phi_cntct(k)) + vtnz(3,k)*dsin(phi_cntct(k)))/dsqrt(vtnz(1,k)*vtnz(1,k) + (vtnz(2,k)*dcos(phi_cntct(k)) + vtnz(3,k)*dsin(phi_cntct(k)))**2.0d0)
    else
        frich(k) = 0.0d0
        fricv(k) = 0.0d0
    end if
end do
   
forall (k = 1:hic_lhi+2)
    ftnz(1,k) =  frich(k)
    ftnz(2,k) = -fcr(k)*dsin(phi_cntct(k)) + fricv(k)*dcos(phi_cntct(k))
    ftnz(3,k) =  fcr(k)*dcos(phi_cntct(k)) + fricv(k)*dsin(phi_cntct(k))
end forall
   
   !write(*,*) 'mark10'
   !write(*,*) 'ftnz',ftnz
   !pause
do k = 1,hic_lhi+2
    Mtnrvstemp = 0.0d0
    forall (i = 1:3, j = 1:3)
        Mtnrvstemp(i,j) = Mtnreverse(i,j,k)
    end forall
    ftnztemp = 0.0d0
    forall (i = 1:3)
        ftnztemp(i) = ftnz(i,k)
    end forall
    ffixtemp = 0.0d0
    do i = 1,3
        ffixtemp(i) = Mtnrvstemp(i,1)*ftnztemp(1) + Mtnrvstemp(i,2)*ftnztemp(2) + Mtnrvstemp(i,3)*ftnztemp(3)
    end do
    !call DGEMM('n','n',3,1,3,1.0d0,Mtnrvstemp,3,ftnztemp,3,0.0d0,ffixtemp,3)
    forall (i = 1:3)
        ffix(i,k) = ffixtemp(i)
    end forall
    fvt = fvt + ffix(3,k)                 ! fvt in N.
end do
   
do j = 1,hic_lhi+2
    do i = 1,3
        fshp(i,j) = Rnb(i,1)*ffix(1,j) + Rnb(i,2)*ffix(2,j) + Rnb(i,3)*ffix(3,j)
    end do
end do
!call DGEMM('n','n',3,n2-n1+2,3,1.0d0,Rnb,3,ffix,3,0.0d0,fshp,3)          ! fshp in N
   
do k =1,hic_lhi+2
    fshpsum(1) = fshpsum(1) + fshp(1,k)
    fshpsum(2) = fshpsum(2) + fshp(2,k)
    fshpsum(3) = fshpsum(3) + fshp(3,k)
    fshpsum(4) = fshpsum(4) + fshp(3,k)*pan3dmpshp(2,k)/thousand - fshp(2,k)*pan3dmpshp(3,k)/thousand       ! moment in N*m.
    fshpsum(5) = fshpsum(5) - fshp(3,k)*pan3dmpshp(1,k)/thousand + fshp(1,k)*pan3dmpshp(3,k)/thousand
    fshpsum(6) = fshpsum(6) + fshp(2,k)*pan3dmpshp(1,k)/thousand - fshp(1,k)*pan3dmpshp(2,k)/thousand
end do

end subroutine