subroutine newedge(in_pt,out_pt,cen_pt,dl,n_new_pt,new_edge,iceupdt_flag)
implicit none

real(kind = 8), external :: kai

real(kind = 8), parameter :: pi = 3.14159265358979d0, zero = 1.0d-16, zero8 = 1.0d-8
real(kind = 8) :: in_pt(2),out_pt(2),cen_pt(2)  ! starting point of arc(i.e., new_ice_in), ending point of arc(new_ice_out),center point of breaking crack(c_cenbrk)
real(kind = 8) :: dl                            ! chord length, input, 50mm 
integer :: i, iceupdt_flag, n_new_pt           ! n_new_pt - number of new generated arc points between starting and ending points
real(kind = 8) :: new_edge(2,5000)

real(kind = 8) :: theta_itm, theta_1, theta_2, theta_12, dtheta  ! dtheta - angle increment
real(kind = 8) :: theta_i(5000)                 ! angle coordinate of each inner new edge point
real(kind = 8) :: r, r2
real(kind = 8) :: vector_1(2), vector_2(2)

iceupdt_flag = 0

vector_1(1) = in_pt(1)-cen_pt(1)
vector_1(2) = in_pt(2)-cen_pt(2)
vector_2(1) = out_pt(1)-cen_pt(1)
vector_2(2) = out_pt(2)-cen_pt(2)


r = dsqrt(vector_1(1)*vector_1(1)+vector_1(2)*vector_1(2))          ! breaking radius
r2 = dsqrt(vector_2(1)*vector_2(1)+vector_2(2)*vector_2(2))          ! breaking radius

if (r<=zero) then
    write(*,*) 'ee01'
    pause
end if

if (dabs(r-r2)>10.0d0) then
    write(*,*) 'ee05'
    write(*,*) vector_1
    write(*,*) vector_2
    write(*,*) 'r:',r,'r2:',r2
    pause
end if

theta_itm = dacos(1.0d0-0.5d0*dl*dl/(r*r))

theta_1 = kai(vector_1(2),vector_1(1))
theta_2 = kai(vector_2(2),vector_2(1))

if (theta_2>theta_1) then
    theta_12 = theta_2 - theta_1                    ! opening angle of broken piece, but not the one used in Pf calculation
else
    theta_12 = theta_2 - theta_1 + 2.0d0*pi
end if

if(theta_12<=zero8) then
    write(*,*) 'ee03'
    pause
    !stop
end if

if (theta_12<theta_itm) then
    write(*,*) 'ee04'
    pause
    iceupdt_flag = 1
    return
else
    n_new_pt = int(theta_12/theta_itm)              ! number of points inbetween
end if

dtheta = theta_12/dble(n_new_pt+1)

if (n_new_pt>=1) then
    do i = 1,n_new_pt
        theta_i(i) = theta_1 + dtheta*dble(i)
        new_edge(1,i) = cen_pt(1)+r*dcos(theta_i(i))              ! x,y coordinates in earth frame
        new_edge(2,i) = cen_pt(2)+r*dsin(theta_i(i))
    end do
else
    write(*,*) 'ee05'
    pause
    stop
end if

end